/*                               -*- Mode: C -*- 
 * tg-action.c -- 
 * 
 * Copyright (C) 1999-2005 LAAS/CNRS
 * 
 * Author          : Francois Felix Ingrand
 * Created On      : Mon Jul 19 15:01:12 1999
 * Last Modified By: Francois Felix Ingrand
 * Last Modified On: Wed Sep 10 12:20:12 2003
 * Update Count    : 11
 * Status          : OK
 * 
 * $Id$
 */

#include <stdio.h>

#include "listPack.h"

#include "macro-pub.h"
#include "opaque-pub.h"
#include "constant-pub.h"
#include "oprs-type-pub.h"

#include "pu-mk-term_f.h"
#include "pu-parse-tl_f.h"
#include "pu-enum_f.h"

#include "oprs-type_f-pub.h"


#include "user-external.h"
#include "user-action.h"
#include "user-ev-function.h"
#include "user-ev-predicate.h"
#include "int-graph_f-pub.h"
#include "intention_f-pub.h"

#include "portLib.h"
#include "csLib.h"

#include "user-decl-oprs-com.h"
#include "user-decl-oprs-com_f.h"
#include "user-decl-oprs-post.h"
#include "user-decl-oprs-post_f.h"

#include "transgen_f-pub.h"

void declare_user_action(void)
{
     declare_oprs_com_user_action();
     declare_oprs_post_user_action();

     declare_transgen_user_action();
     return;
}

void declare_user_eval_funct(void)
{
     declare_oprs_com_evaluable_function();
     PU_enum_declare_user_eval_funct();

     declare_transgen_user_eval_funct();

     return;
}

void declare_user_eval_pred(void)
{
     declare_oprs_com_evaluable_predicate();
     declare_oprs_post_evaluable_predicate();

     PU_enum_declare_user_eval_pred();

     declare_transgen_user_eval_pred();

     return;
}


Intention_List transgen_par_intention_scheduler_with_priority(Intention_List l)
{
     Intention_List l2 = make_list();
     Intention *intention;
     PBoolean first = TRUE;
     int prio = 0;		/* Initialized to please gcc... */

     l = (Intention_List)sort_list_func(l,&intention_list_sort_by_priority);
     loop_through_list(l, intention, Intention *)
	  if (first) {
	       prio = intention_priority(intention);
	       add_to_head(l2, intention);
	       first = FALSE;
	  } else
	       if (prio == intention_priority(intention))
		    add_to_head(l2, intention);
	       else
		    break;
     oprs_free_list(l);

     return l2;
}

Intention_List transgen_intention_scheduler_time_sharing_with_sort_predicate(Intention_List l)
{
     if (intention_list_sort_predicate)
	  l = (Intention_List)sort_list_func(l,intention_list_sort_predicate);
     return l;
}

void start_kernel_user_hook(char *name)
{
/*     intention_scheduler = &intention_scheduler_time_sharing; */
     intention_scheduler = &transgen_intention_scheduler_time_sharing_with_sort_predicate;
     intention_par_scheduler = &transgen_par_intention_scheduler_with_priority;
     intention_list_sort_predicate = &intention_list_sort_by_priority;
     main_loop_pool_sec = 0L;
#ifdef VXWORKS
     main_loop_pool_usec = 500000L;
#else
     main_loop_pool_usec = 100000L;
#endif
/*      disable_slist_compaction(); This is a temporary fix... remove it when version > 1.3.3 */
     PU_init_atom_enum_hash();

     init_global_enum();

     init_oprs_com(name);
     init_rqst_type_table();
     init_module_table();

     init_oprs_post();
     init_poster_function_table();

     start_kernel_transgen_user_hook();
}


void end_kernel_user_hook()
{
     fprintf(stderr,"Shutting down modules...\n");
     end_module();
     fprintf(stderr,"Shutting down oprs-com...\n");
     end_oprs_com();
     fprintf(stderr,"Shutting down oprs-post...\n");
     end_oprs_post();
     fprintf(stderr,"Open PRS Supervision shutting down...\n");

     end_kernel_transgen_user_hook();
}
